; *********************************************************************************************
; * ROTINA PARA RECEPTOR ON/OFF PARA UMA SADA COM ENCODER HT6P20B
; * ESTA ROTINA ARMAZENA 42 CDIGOS OU 14 CONTROLES REMOTO COM 3 BOTES EM CADA CONTROLE
; * AUTOR...: Deivid Floriani Antunes
; * VERSO..: 0.01
; * DATA DE INCIO....: 15/06/2013
; * DATA DE TRMINO....: 17/06/2013
; * CIDADE..: LAGES - SC - BRASIL
; * E-MAIL..: DEIVIDFLORIANI@YAHOO.COM.BR
; * FACEBOOK..: https://www.facebook.com/deividfloriani
; * FLICKR..: http://www.flickr.com/photos/deividfloriani/
; * CELULAR..: 055 49 9991-9087
; *********************************************************************************************
;
;FUNCIONAMENTO
;APS ALIMENTAR O CIRCUITO, O LED LEARN IR PISCAR POR 2 SEGUNDOS. 
;MEMORIZA AT 42 BOTES, EX: 14 CONTROLES DE 3 BOTES OU 21 CONTROLES 
;DE 2 BOTES) OU DESEJAR USAR O MESMO CONTROLE PARA 2 OU 3 
;RECEPTORES (DE ACORDO COM A QUANTIDADE DE BOTES DO CONTROLE 
;REMOTO QUE PODE SER, DE 2 OU 3 BOTES), SIGA OS SEGUINTES  
;PROCEDIMENTOS: 
;1- PRESSIONE O BOTO DE LEARN POR 2 SEGUNDOS. O LED LEARN ACENDE. 
;PRESSIONE UM DOS BOTES DO CONTROLE REMOTO. O LED LEARN APAGA, 
;CONFIRMANDO QUE O CDIGO FOI ARMAZENADO NA MEMRIA DO RECEPTOR.  
;2- CASO QUEIRA QUE O MESMO RECEPTOR FUNCIONE COM OS 2 OU 3 BOTES 
;DO CONTROLE REMOTO, REPITA O PROCEDIMENTO 1 PARA CADA BOTO. 
;3- CASO QUEIRA USAR O MESMO CONTROLE PARA 2 OU 3 RECEPTORES, 
;MANTENHA PRESSIONADO O BOTO DE CODIFICAO POR 5 SEGUNDOS. O LED 
;LEARN FICA ACESO DURANTE ESTE PERODO, PISCA DUAS VEZES E APAGA, 
;CONFIRMANDO QUE A MEMRIA DO RECEPTOR EST LIMPA. REPITA O 
;PROCEDIMENTO 3 COM OS OUTROS RECEPTORES. FEITO ISSO, EXECUTE O 
;PROCEDIMENTO 1 EM TODOS OS RECEPTORES, PRESSIONANDO PARA CADA 
;RECEPTOR UM BOTO DIFERENTE DO CONTROLE REMOTO. 
;OBS: O LED LEARN PISCA RAPIDAMENTE 5 VEZES SE DURANTE A 
;PROGRAMAO, J EXISTIR UM CDIGO IGUAL CADASTRADO NO RECEPTOR E 
;PISCA RAPIDAMENTE 5 VEZES + 2 PISCADAS LENTAS, SE A MEMRIA DO 
;RECEPTOR ESTIVER CHEIA.
;
;ENTRADAS:    
;			  BOTO LEARN - PINO 4
;			  SINAL DO RECEPTOR - PINO 2
;SADAS:      
;             LED LEARN - PINO 3
;			  LED SAIDA - PINO 5
;			  LED INDICADOR DE SINAL DE RECEPO - PINO 7

LIST P=12F629, R=HEX
#INCLUDE <P12F629.INC>
ERRORLEVEL -302
          __CONFIG  _BODEN_OFF & _CP_ON & _PWRTE_ON & _WDT_OFF & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT

;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                    PAGINAO DE MEMRIA                         *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;DEFINIO DE COMANDOS DE USURIO PARA ALTERAO DA PGINA DE MEMRIA

#DEFINE BANK0 BCF STATUS, RP0
#DEFINE BANK1 BSF STATUS, RP0

;***************************************************************************************
;      					        PROGRAMA INICIAL
;***************************************************************************************
;      					      PAGINAO DE VARIAVEIS
;*************************************************************************************** 
	CBLOCK  0X20
    RES3
  	RES2
	RES1
	RES0
	AUX
	BITCOUNTER
	FLAGS
	Z2
	Z1
	Z3
	Y1
	Y2
	CONT
	AUX2
	LC
	HC
 	RES3A
	RES2A
	RES1A
	RES0A
	R0
	R1
	R2
	R3
	ADDRESS
	TMP
	TMP_SALVO
	d1
    d2
	d3
	VAR
	TEMPO1
	TEMPO2
	TEMPO3
	TEMP2
	AUXILIAR
	DADO
	MAX
	ESPERAR1
	ESPERAR2
	TESTE
    ENDC

;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                         CONSTANTES                              *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; DEFINIO DE TODAS AS CONSTANTES UTILIZADAS PELO SISTEMA

TMAX    	EQU .50     		;TEMPO MAXIMO DO SINAL LOW
T_DESL_LED  EQU .20     		;TEMPO MXIMO QUE LEDS FICAM ACESOS APS CESSAR TRANSMISSO

;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                           ENTRADAS                              *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; DEFINIO DE TODOS OS PINOS QUE SERO UTILIZADOS COMO ENTRADA

#DEFINE LRN		    GPIO,3 		; ENTRADA DO BOTO LEARN
#DEFINE SIN 	    GPIO,5 		; ENTRADA DO SINAL DO RECEPTOR

;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                           SADAS                                *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; DEFINIO DE TODOS OS PINOS QUE SERO UTILIZADOS COMO SADA

#DEFINE LED_LEARN  	GPIO,4  	;SADA DO LED INDICADOR DO BOTO LEARN
#DEFINE LED_SAIDA 	GPIO,2  	;SADA DO RELE
#DEFINE LED_SINAL   GPIO,0  	;SADA LED INDICADOR DE SINAL DE RECEPO

;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
;*                        FLAGS INTERNOS                           *
;* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; DEFINIO DE TODOS OS FLAGS UTILIZADOS PELO SISTEMA

#DEFINE	FLAG		FLAGS,0   	;FLAG DE SITUAO
#DEFINE	FLAG1		FLAGS,1   	;FLAG DE NOVA LEITURA
#DEFINE	APRENDER	FLAGS,2   	;FLAG DE 'LEARN' APRENDER
#DEFINE	FLAGLED0	FLAGS,3  	;FLAG DE SITUAO

;***************************************************************************************
;      						     INICIALIZAO DA EEPROM
;***************************************************************************************
	ORG H'2100'
	DE 0X00
;***************************************************************************************
;      							INICIO DE MEMRIA DE PROGRAMA
;***************************************************************************************
	ORG 0X00
	GOTO INICIO

;***************************************************************************************
;      								VETOR DE INTERRUPO 
;*************************************************************************************** 
	ORG 0X04
	RETFIE

;***************************************************************************************
;       					configuraes dos sfr's do sistema 
;*************************************************************************************** 
INICIO:
								;Mnima  = 0x00 -> 860 / 880 Khz 
								;Central = 0x80 -> 1.150 / 1.170 Mhz 
								;Mxima  = 0xFC -> 1.380 / 1.400 Mhz
	BANK1

	MOVLW 0X00    				;VALOR DE CALIBRAO DO OSCILADOR - EST CALIBRADO COM A FRENQUENCIA MXIMA
	MOVWF OSCCAL  				;REGISTRADOR DE CALIBRAO
	MOVLW B'00101000'			;ENTRADAS: GPIO  - SADAS: GPIO 
	MOVWF TRISIO				;CONFIGURA ENTRADAS E SADAS DA PORTA A
	MOVLW B'00000000'   		;INTERRUPES DESLIGADAS
	MOVWF INTCON
	MOVLW B'00000000'
	MOVWF WPU					;DESATIVA OS PULL-UPS
	MOVLW B'00000000' 
	MOVWF IOC			
	MOVLW B'10000111'			; desliga pull ups / preescaler trm0 16 65,535 ms
	MOVWF OPTION_REG

	BANK0
	MOVLW  0X07
	MOVWF  CMCON				;DESLIGA COMPARADORES
	CLRF   GPIO					;RESET PORT
	CLRF   FLAGS   				;APAGA REGISTRADOR DE FLAGS
  	CLRF   VAR					;LIMPA VAR
	CLRF   RES3
    CLRF   RES2
    CLRF   RES1
	CLRF   RES0
    CLRF   HC
    CLRF   LC
	MOVLW  .2					;MOVE 5 PARA A VARIAVEL VAR
	MOVWF  VAR
	BSF    LED_LEARN 			;ACENDE LED LEARN
	CALL   DELAY_500MS			;DELAY
	BCF    LED_LEARN 			;APAGA LED LEARN
	CALL   DELAY_500MS
	DECFSZ VAR, F				;DESCREMENTA A VARIAVEL VAR FAZENDO O LED PISCAR POR 5 SEGUNDOS
	GOTO   $-5					;RETORNA 5 LINHAS PARA CIMA
	MOVLW  .28  				;PREPARA PARA A RECEPO COM NUMERO DE BITS A RECEBER
	MOVWF  BITCOUNTER
    BCF    FLAG   				;LIMPA FLAG E REGISTRADORES DE RECEPO

;********************************************************************************************
;                                     ROTINA PRINCIPAL                           
;********************************************************************************************

MAIN
	BTFSC  LRN
	GOTO   VERIFICA_RECEPTOR
	GOTO   VERIFICA_BOTAO   

;*********************************************************************************************
;							ROTINA DE CONTROLE DO BOTO LEARN
;*********************************************************************************************
VERIFICA_BOTAO
	CALL   DELAY_LEARN 
VERIFICA_LEARN
    BTFSC  LRN
	GOTO   VERIFICA_RECEPTOR
	DECFSZ TEMPO1,F
	GOTO   VERIFICA_LEARN
	DECFSZ TEMPO2,F
	GOTO   VERIFICA_LEARN
	GOTO   $+1
	NOP
;SE CHEGOU AQUI O BOTO LEARN VAI SETAR O FLAG APREENDER E ENTO O PROGRAMA
;VAI FICAR ESPERANDO O CDIGO POR + OU - 5 SEGUNDOS, CASO CONTRRIO SE O BOTO CONTINUAR PRESSIONADO
;TODOS OS CDIGOS SERO APAGADOS E CASO O DEPOIS DE 5 SEGUNDOS SE NO RECEBER NENHUM CDIGO
;O PROGRAMA VOLTA AO FUNCIONAMENTO NORMAL
    BSF	   LED_LEARN 
	BSF    APRENDER           	;FLAG QUE SINALIZA QUE O BOTO LEARN FOI APERTADO
	BCF	   LED_SAIDA
	CLRF   Z1
	CLRF   Z2
	CLRF   Z3 
	CLRF   TEMPO3
	MOVLW  .3
    MOVWF  TEMPO3
	MOVLW  .100
    MOVWF  Z1		       	 	;RECARGA DO TEMPO DE APAGAMENTO
  	MOVLW  .150
    MOVWF  Z2		         	;RECARGA DO TEMPO DE APAGAMENTO 
	MOVLW  .11
    MOVWF  Z3		        	;RECARGA DO TEMPO DE APAGAMENTO  
 	BTFSC  LRN  
    GOTO   VERIFICA_RECEPTOR
 	GOTO   APAGAMENTO

;ROTINA DE APAGAMENTO CASO BOTO LEARN PRESSIONADO POR 10S 
;APAGAR TODOS OS CONTROLES DA MEMRIA

APAGAMENTO  
	BTFSC  LRN  
    GOTO   VERIFICA_RECEPTOR             
    DECFSZ Z1,F
    GOTO   APAGAMENTO 
	DECFSZ Z2,F
    GOTO   APAGAMENTO 	
	DECFSZ Z3,F
    GOTO   APAGAMENTO 
   	CALL   APAGA_EEPROM     	;ATINGIU TEMPO MAXIMO: APAGAR MEMRIA
   	GOTO   TESTE_LEARN 

;PROTEO DO PROGRAMA CASO A CHAVE LEARN TRAVE OU ENTRE EM CURTO-CIRCUITO OU NA HORA EM QUE
;O DEDO PARAR DE PRESSIONAR O BOTO, DE UM RUDO NA TECLA E ELE ENTRE NA PROGRAMAO DO LEARN
;NOVAMENTE	

TESTE_LEARN                
	CALL   DELAY_LEARN
	BTFSC  LRN	
	GOTO   $+2
	GOTO   TESTE_LEARN 
	DECFSZ TEMPO1,F
	GOTO   $-4
	DECFSZ TEMPO2,F
	GOTO   $-6
	GOTO   MAIN
	

;*********************************************************************************************
;									ROTINA DE RECEPO
;*********************************************************************************************
;---------------------------------------------------------------------------------------------
;TEMPO DE ESPERA DE APRENDIZADO, CASO O BOTAO LEARN TENHA SIDO PRESSIONADO, CASO NO RECEBA
;NENHUM SINAL, DEPOIS DE + OU - 10 SEGUNDOS ELE DESLIGA O PROCESSO DE APRENDIZADO 
VERIFICA_RECEPTOR
	BCF	   LED_SINAL           	;LED INDICADOR DE SINAL RECEBIDO
	BTFSS  APRENDER
	GOTO   RECEPTOR
	DECFSZ Z1,F
    GOTO   RECEPTOR 
	DECFSZ Z2,F
    GOTO   RECEPTOR	
	DECFSZ TEMPO3,F
    GOTO   RECEPTOR
	BCF	   APRENDER
	CLRF   TEMPO3
	MOVLW  .5
	MOVWF  TEMPO3
	BCF    LED_LEARN
	CALL   DELAY_AGUARDE
    BSF    LED_LEARN
	CALL   DELAY_AGUARDE
	DECFSZ TEMPO3,F
	GOTO   $-5
	BCF    LED_LEARN
	GOTO   RECEPTOR	
RECEPTOR  
    BTFSS  FLAG     	   		;TESTA FLAG DE HUM/ZERO RECEBIDO
	GOTO   L2       	   		;FLAG=0
    BTFSS  SIN      	   		;SIN ? TESTA SINAL DE ENTRADA DO RECEPTOR DE RF
	GOTO   M0       	  		;SIN=0
;-----------------------------------------------------------------------------------------
;AQUI COMEA A ANLISE DO PIC SOBRE O SINAL DO RECEPTOR. QUANDO NINGUM EST APARETANDO O
;CONTROLE O RECEPTOR ENVIA NA MAIOR PARTE DO TEMPO O SINAL 1 OU SEJA POSITIVO, QUANDO O 
;BOTO DO CONTROLE REMOTO  PRESSIONADO, ELE ENVIA O 0 ZERO NA MAIOR PARTE DO TEMPO
;----------------------------------------------------------------------------------------
L2
	BTFSS  SIN      	   		;TESTA ENTRADA DO RECEPTOR SE ESTIVER EM 1 PULA 2 LINHAS
    GOTO   LA1      	   		;SIN=0
	BSF    FLAG     	   		;SIN=1
    INCF   HC,F
    BTFSC  STATUS,Z
    DECF   HC,F
    GOTO   LA2	           		;VAI CONTAR TEMPO DE 50 MICRO SEGUNDOS
LA1
    INCF   LC,F            		;INCREMENTA REGISTRADOR DE LOW SIGNAL NA ENTRADA RF
    BTFSC  STATUS,Z
    DECF   LC,F
LA2
    DECFSZ Y1,F            		;CONTADOR DE TEMPO DE DESLIGAMENTO DE SAIDAS
    GOTO   J0
    DECFSZ Y2,F            		;CONTADOR DE TEMPO DE DESLIGAMENTO DE SAIDAS
    GOTO   J0
	BCF    FLAGLED0
    INCF   Y1,F
    INCF   Y2,F
J0

	MOVLW  .9              		;.9 = 50 MICROSEG    (ACERTA TEMPO ENTRE LEITURAS DA ENTRADA DE RF)
    MOVWF  CONT
    DECFSZ CONT,F
    GOTO   $-1  
    GOTO   MAIN


;-----------------------------------------------------
;INICIO DA PARTE DO PROGRAMA QUE TESTA OS BITS RECEBIDOS
M0	
    MOVFW  LC		     	   ;TESTA SE NO PASSOU DO LIMITE MAXIMO DE TEMPO EM LOW NA ENTRADA DE RF
    SUBLW  TMAX
    BTFSS  STATUS,C
    GOTO   LIMPA_RECEPTOR 	   ;C=0 (-)  -  LC>TMAX (REJEITAR DADO - PAUSA INICIAL)
   	MOVFW  HC			 	   ;OBTEM O VALOR DE 'CARRY'(HUM OU ZERO)
    SUBWF  LC,W    
    RRF    RES3,F              ;DESLOCA  O BIT NOS REGISTRADORES DE RESULTADO
    RRF    RES2,F
    RRF    RES1,F
    RRF    RES0,F
    DECFSZ BITCOUNTER,F        ;DECREMENTA O CONTADOR DE BITS A SER RECEBIDO
	GOTO   LE_PROXIMO
    GOTO   CONTINUA             
LE_PROXIMO					   ;LE O PROXIMO BIT
	BCF    FLAG   			   ;LIMPA FLAG E REGISTRADORES DE RECEPO
    CLRF   HC
    CLRF   LC
	GOTO   MAIN
CONTINUA
    MOVLW  .4             	   ;DESPREZA OS BITS DE 'ANTICODE' 1010
    MOVWF  BITCOUNTER

ACERTA
    BCF    STATUS,C
    RRF    RES3,F
    RRF    RES2,F
    RRF    RES1,F
    RRF    RES0,F         	   ;RESULTADO FICA SOMENTE EM RES2 A RES0,DESPREZA RES3
	DECFSZ BITCOUNTER,F
    GOTO   ACERTA
    BTFSC  FLAG1          	   ;TESTA SE  A PRIMEIRA OU A SEGUNDA RECEPO
	GOTO   PULA1
    MOVFW  RES2                ;SALVA A PRIMEIRA LEITURA PARA COMPARAO COM UMA SEGUNDA
    MOVWF  RES2A
    MOVFW  RES1
    MOVWF  RES1A    
    MOVFW  RES0
    MOVWF  RES0A	
    BSF    FLAG1		       ;SETA FLAG DE PRIMEIRA RECEPO
    GOTO   LIMPA_RECEPTOR

PULA1
	BCF    FLAG1               ;SEGUNDA RECEPO, COMPARA COM A PRIMEIRA
	MOVFW  RES2
    XORWF  RES2A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC
    MOVFW  RES1
    XORWF  RES1A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC
	MOVFW  RES0
    XORWF  RES0A,W
    BTFSS  STATUS,Z
    GOTO   RESETAC	  	       ;ERRO DE RECEPO
    GOTO   VERIFICA_VAZIOS     ;OK - BOA RECEPO

RESETAC
	CLRF   RES3A               ;APAGA RESULTADOS DE COMPARAO
    CLRF   RES2A
    CLRF   RES1A
	CLRF   RES0A
	GOTO   LIMPA_RECEPTOR
;-------------------------------------
;ROTINA PARA ELIMINAR RECEPO 'FFFFFF' (MEMRIA VIRGEM)
; AT AQUI:
; Recebeu todos os 24 bits em Byte1,Byte2,Byte3
; Byte1=LSB
; Byte3=MSB

VERIFICA_VAZIOS 		       ;VERIFICA SE SO CDIGOS ESTAO VAZIOS;
	BSF	   LED_SINAL           ;LED INDICADOR DE SINAL RECEBIDO
	MOVLW  0XFF		
	BCF    STATUS, Z
	XORWF  RES2,W
	BTFSS  STATUS,Z
	GOTO   $+2
	GOTO   KSET2
	MOVLW  0XFF
	BCF    STATUS, Z
	XORWF  RES1,W
	BTFSS  STATUS,Z
	GOTO   $+2
	GOTO   KSET2
	MOVLW  0XFF
	BCF    STATUS, Z
	XORWF  RES0,W
	BTFSS  STATUS,Z
	GOTO   RECEBEU_OK
	GOTO   KSET2
;-------------------------------------------------------------------------------------------
;VERIFICA SE O CDIGO E SOMENTE PARA COMPARAO E SE J EST CADASTRADO ENTAO VAI ACIONAR O LED
;OU SE O BOTO LEARN FOI PRESSIONADO E FOI MANDANDO A MEMORIA APRENDER UM CDIGO, QUE DA
;O CDIGO VAI SER ARMAZENADO, MAS SE O CDIGO FOR IGUAL A ALGUM OUTRO CDIGO ARMAZENADO 
;NA MEMRIA, A PROTEO DE CDIGO IGUAL  HABILITADA E O LED LEARN PISCA RPIDO 5 VEZES 
;PARA INDICAR QUE J POSSUI ESSE CDIGO NA MEMRIA A MESMA INDICAO DE PISCADA SERVE PARA 
;INDICAR QUE A MEMRIA EST CHEIA.

RECEBEU_OK	
	CLRF   AUXILIAR
	CLRF   MAX
	MOVLW  .1
	MOVWF  AUXILIAR
	MOVLW  .126
	MOVWF  MAX
COMPARA
	CALL   LE_E2PROM
	MOVF   DADO, W
	BCF    STATUS, Z
	XORWF  RES0, W
	BTFSS  STATUS, Z
	GOTO   OUTRO
	INCF   AUXILIAR, F
	CALL   LE_E2PROM
	MOVF   DADO, W
	BCF    STATUS, Z
	XORWF  RES1, W
	BTFSS  STATUS, Z
	GOTO   OUTRO
	INCF   AUXILIAR, F
	CALL   LE_E2PROM
	MOVF   DADO, W
	BCF    STATUS, Z
	XORWF  RES2, W
	BTFSS  STATUS, Z
	GOTO   OUTRO
	GOTO   VERIFICA_COND
OUTRO
	INCF   AUXILIAR, F
	DECFSZ MAX, F
	GOTO   COMPARA
	BTFSS  APRENDER
	GOTO   KSET2 
	GOTO   APRENDE
;---------------------------------------------------------------------------------------------
;VERIFICA CONDIO DE ACIONAMENTO, PROTEO PARA CASO O BOTO LEARN TENHA SIDO PRESSIONADO E 
;J EXISTIA O MESMO CDIGO NA MEMRIA DO PIC				
VERIFICA_COND
	BTFSS  APRENDER
	GOTO   ACIONAR
	BCF	   APRENDER
	BCF	   LED_SINAL	
	CLRF   TEMPO3
	MOVLW  .5
	MOVWF  TEMPO3
	BCF    LED_LEARN
	CALL   DELAY_AGUARDE
    BSF    LED_LEARN
	CALL   DELAY_AGUARDE
	DECFSZ TEMPO3,F
	GOTO   $-5
	BCF    LED_LEARN
	GOTO   KSET2
;----------------------------------------------------------------------------------------------
;ROTINA DE APRENDIZADO DO CDIGO DO CONTROLE GRAVAO NA EEPROM
APRENDE
	CLRF   TESTE	              ;PROTEO DO CDIGO PARA MEMRIA CHEIA
	MOVLW  .126
	MOVWF  TESTE						
    BCF	   LED_SINAL              
	MOVLW  0X00
	MOVWF  AUXILIAR
	CALL   LE_E2PROM
	MOVF   DADO,W
	MOVWF  AUXILIAR
    BCF    STATUS, Z
	XORWF  TESTE,W
    BTFSS  STATUS,Z
	GOTO   $+2
	GOTO   MEMORIA_CHEIA	
	INCF   AUXILIAR, F
	MOVF   RES0, W
	MOVWF  DADO
	CALL   GRAVA_E2PROM
	INCF   AUXILIAR, F
	MOVF   RES1, W
	MOVWF  DADO
	CALL   GRAVA_E2PROM
	INCF   AUXILIAR, F
	MOVF   RES2, W
	MOVWF  DADO
	CALL   GRAVA_E2PROM
	MOVF   AUXILIAR, W
	MOVWF  DADO
	MOVLW  0X00
	MOVWF  AUXILIAR
	CALL   GRAVA_E2PROM
	BCF    APRENDER
	BCF    LED_LEARN
	GOTO   KSET2

MEMORIA_CHEIA
	BCF	   LED_SINAL
	BCF	   APRENDER
	CLRF   TEMPO3
	MOVLW  .5
	MOVWF  TEMPO3
	BCF    LED_LEARN
	CALL   DELAY_AGUARDE
    BSF    LED_LEARN
	CALL   DELAY_AGUARDE
	DECFSZ TEMPO3,F
	GOTO   $-5
	BCF    LED_LEARN
	CALL   DELAY_500MS
    BSF    LED_LEARN
	CALL   DELAY_500MS
	BCF    LED_LEARN
	CALL   DELAY_500MS
    BSF    LED_LEARN
	CALL   DELAY_500MS
	BCF    LED_LEARN
	GOTO   KSET2
;---------------------------------------------------------------------------------------------
;PARTE RESPONSVEL PELO CONTROLE DO LED_SAIDA
ACIONAR 
	BTFSC  FLAGLED0
    GOTO   SEGUE
    CALL   CONTROLE
KSET2
	BSF    FLAGLED0
    GOTO   KCONT			;NO TESTA MAIS NADA
;--------------------------------------------------------------------------------------------
;ESSA ROTINA SEGUE,SERVE PARA MANTER O MESMO BRILHO DO LED INDICADOR, QUANDO O CONTROLE J EST 
;GRAVADO NA MEMRIA DO PIC, POIS DA A LEITURA  MAIS RPIDA DO QUE SE NO ESTIVESSE GRAVADO, 
;POIS SE ELE EST GRAVADO ELE ACHA MAIS RPIDO O CDIGO, POIS NO PRECISA VERIFICAR A MEMRIA 
;INTEIRA, AINDA MAIS SE O CONTROLE ESTIVER GRAVADO NAS PRIMEIRAS POSIES DA MEMRIA
SEGUE
	CALL   DELAY_1MS		;CHAMA ROTINA DE DELAY DE 1MS
	CALL   DELAY_1MS		;CHAMA ROTINA DE DELAY DE 1MS
	CALL   DELAY_1MS		;CHAMA ROTINA DE DELAY DE 1MS
	CALL   DELAY_1MS		;CHAMA ROTINA DE DELAY DE 1MS	
KCONT
    MOVLW  T_DESL_LED  		;RECARGA DO TEMPORIZADOR DE DESLIGAMENTO
    MOVWF  Y2
    MOVLW  .255
    MOVWF  Y1
    GOTO   LIMPA_RECEPTOR


;*********************************************************************************************
;								  SUBROTINAS DO PROGRAMA
;*************************************************************************************************************
; PARTE DO PROGRAMA RESPONSVEL PELA MEMRIA DO PIC 12F629
;*************************************************************************************************************
;ROTINA DE GRAVAO DA EEPROM - CHAMADA COM ENDEREO EM AUXILIAR E DADO EM DADO
;*************************************************************************************************************
GRAVA_E2PROM
	MOVF   AUXILIAR, W 
	BANK1
	MOVWF  EEADR
	BANK0
	MOVF   DADO, W
	BANK1
	CLRF   EEDATA
	MOVWF  EEDATA
	BSF    EECON1,WREN
	MOVLW  0X55
	MOVWF  EECON2
	MOVLW  0XAA
	MOVWF  EECON2
	BSF    EECON1,WR
	CLRF   ESPERAR1
	CLRF   ESPERAR2
	MOVLW  .182
	MOVWF  ESPERAR1
	MOVLW  .12
	MOVWF  ESPERAR2
TENT
	BTFSC  EECON1,WR
	GOTO   $+2
	GOTO   $+7
	DECFSZ ESPERAR1
	GOTO   TENT
	DECFSZ ESPERAR2
	GOTO   TENT
	GOTO   $+1
	NOP
	BCF    EECON1,WREN
	BANK0
	RETURN	
;********************************************************************************************
;ROTINA DE LEITURA DA EEPROM - CHAMADA COM ENDEREO EM AUXILIAR E RETORNA COM DADO EM DADO
;********************************************************************************************
LE_E2PROM
	CLRF   DADO
	MOVF   AUXILIAR, W
	BANK1
	MOVWF  EEADR
	BSF    EECON1, RD
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	MOVF   EEDATA, W
	BANK0
	MOVWF  DADO
	RETURN

;*********************************************************************************************
;								ROTINA DE LIMPEZA DA MEMRIA EEPROM
;*********************************************************************************************
APAGA_EEPROM 	
	BCF    APRENDER
	CLRF   MAX
	MOVLW  .127
	MOVWF  MAX
	MOVLW  0X00
	MOVWF  AUXILIAR
	MOVLW  0X00
	MOVWF  DADO
	CALL   GRAVA_E2PROM
APAGANDO
	INCF   AUXILIAR, F
	MOVLW  0XFF
	MOVWF  DADO
	CALL   GRAVA_E2PROM
	DECFSZ MAX, F
	GOTO   APAGANDO
   	BCF    LED_LEARN
    CALL   DELAY_500MS
    BSF    LED_LEARN
	CALL   DELAY_500MS
	BCF    LED_LEARN
	CALL   DELAY_500MS
    BSF    LED_LEARN
	CALL   DELAY_500MS
	BCF    LED_LEARN
	CALL   DELAY_500MS
    RETURN 

;*********************************************************************************************
;								 DELAYS DO PROGRAMA
;*********************************************************************************************
;***********************************************************************************************************
;ROTINA DE DELAY DE DO BOTO LEARN
;***********************************************************************************************************
DELAY_LEARN			  ;DELAY DE SEGURANA PARA EVITAR QUE UM RUDO ACIONE A TECLA LEARN = DELAY DE 80MS	
	CLRF   TEMPO1
	CLRF   TEMPO2
	MOVLW  .30
	MOVWF  TEMPO1
	MOVLW  .60
	MOVWF  TEMPO2
	RETURN

;***********************************************************************************************************
;ROTINA DE DELAY DE 500 MS = MEIO SEGUNDO
;***********************************************************************************************************
DELAY_500MS 
			;499994 cycles
	clrf	d1
	clrf	d2
	clrf	d3
	movlw	.3
	movwf	d1
	movlw	.24
	movwf	d2
	movlw	.2
	movwf	d3
Delay_0
	decfsz	d1, f
	goto	$+2
	decfsz	d2, f
	goto	$+2
	decfsz	d3, f
	goto	Delay_0

			;2 cycles
	goto	$+1

			;4 cycles (including call)
	return

;******************************************************************************************
;OUTROS DELAYS

DELAY_AGUARDE				;ROTINA DE ATRASO ENTRE OPERAES DE EEPROM (50 MSEG)
    MOVLW  .50
    MOVWF  R2
    CALL   DELAY_1MS  		;ROTINA DE 1 MILISEGUNDOS
    DECFSZ R2,F
    GOTO   $-2
    RETURN

DELAY_1MS
    MOVLW  .199
    MOVWF  R1
    CLRWDT
    NOP
    DECFSZ R1,F
    GOTO   $-3
    RETURN
;***********************************************************************************************************	
;ROTINA DE CONTROLE DO LED_SAIDA
;************************************************************************************************************		
CONTROLE	
	BTFSS  LED_SAIDA
	BTFSC  LED_SAIDA
	GOTO   $+2
	GOTO   $+3
	BCF    LED_SAIDA
	RETURN
	BSF    LED_SAIDA
	RETURN	
;***********************************************************************************************************
;ROTINA DE LIMPEZA DE VARIVEIS DO RECEPTOR
;***********************************************************************************************************

LIMPA_RECEPTOR         ;SUBROTINA PARA PREPARAR AS VARIAVEIS PARA RECEBER OS CDIGO DO RECEPTOR    
    CLRF   RES3
    CLRF   RES2
    CLRF   RES1
	CLRF   RES0
    CLRF   HC
    CLRF   LC
	MOVLW  .28  		;PREPARA PARA A RECEPO COM NUMERO DE BITS A RECEBER
	MOVWF  BITCOUNTER
    BCF    FLAG   		;LIMPA FLAG E REGISTRADORES DE RECEPO	
	GOTO   MAIN
  
     END